<?php

/**
 * Created by PhpStorm.
 * User: wuxiande
 * Date: 2019/6/27
 * Time: 14:16
 * 中心服务接口
 */
class CenterAction extends Action
{
    /**
     * 系统配置接口
     */
    public function conf_sys(){
        $sql = "SELECT k,v FROM sh_system_config WHERE status=0 ORDER BY id ASC;";
        $arr = M("")->query($sql);
        foreach ($arr as $item){
            $result[$item["k"]]=$item["v"];
        }

        echo json_encode($result);
        exit;
    }

    /**
     * 合作方配置接口
     *
     */
    public function conf_sps(){
        $sql = "SELECT sp.id,sp.code,sp.push_type,sp.push_offset,config.type_code as k,config.v"
                ." FROM sh_sp sp,sh_sp_config config"
                ." WHERE sp.status=0 AND config.status=0 AND sp.id=config.sp_id ORDER BY sp.id ASC;";
        $arr = M("")->query($sql);
        foreach ($arr as $item){
            $result[$item["id"]]["id"]=$item["id"];
            $result[$item["id"]]["code"]=$item["code"];
            $result[$item["id"]]["push_type"]=$item["push_type"];
            $result[$item["id"]]["push_offset"]=$item["push_offset"];
            $result[$item["id"]][$item["k"]]=$item["v"];
        }

        echo json_encode($result);
        exit;
    }

    public function push_log(){

    }

    /**
     * 修改云端片库媒资信息
     *  参数:
     *      spid
     *      push_mode : 是否转推:0不转推,1转推(写入酒店片库)
     *      url :   华数媒资详情url
     */
    public function media_update(){
       $rawData =  @file_get_contents("php://input");
        //echo $rawData."\n";
        $json = json_decode($rawData,true);
        $spid=$json["spid"];
        $pushMode = $json["push_mode"]; //
        $url = $json["jsonUrl"];

        $content = file_get_contents($url);
        $json = json_decode($content,true);
//        var_dump($json);

        $data['type'] = $json["type"];
        $data['title'] = $json["title"];
        $data['code'] = $json["id"];
        $data['description'] = $json["description"];
        $data['url_play'] = $json["playUrl"];
        $data['url_pic'] = $json["picUrl"];
        $data['year'] = substr($json["year"],0,4);
        $data['score'] = floatval($json["score"]);
        $data['region'] = $json["region"];
        $data['actor'] = $json["actor"];
        $data['director'] = $json["director"];
        $data['md5'] = $this->null2str($json["md5"]);
        $data['status'] = intval($json["status"]);
        $data["_starttime"]=$this->null2str($json["startTime"]);
        $data["_updatetime"]=$this->null2str($json["updateTime"]);
        $data["programType"]=$json["programType"];
        $data["nodeId"]=intval($json["nodeId"]);
        $data["sp_id"]=intval($spid);

        $model = D("Media");
        $where["code"]=$data["code"];
        $where["sp_id"]=$data["sp_id"];
        $tmp  = $model->field("id")->where($where)->find();
        $id= $tmp["id"];
//        var_dump($tmp);exit;
        if($id){
            $data['id'] = $id;
            $data["updatetime"]=date('Y-m-d H:i:s');
            $r = $model->save($data);
//            echo $model->_sql();
            if($r){
                echo 'true';
            }else{
                echo 'false';
            }
        }else{
            $id = $model->add($data);
            $data["id"]=$id;
            if($id){
                echo 'true';
            }else{
                echo 'false';
            }
        }
        if ($pushMode=="1") {
            $this->media_auto_push($data);
        }

        exit;
    }
    function null2str($str){
        if (is_null($str)){
            $str="";
        }
        return $str;
    }
    /*
     * 媒资自动转推函数
     * 批量修改媒资状态
     * 批量推送添加
     */
    function media_auto_push(&$data){
        $sp_id=$data["sp_id"];
        $media_id = $data["id"];
        $status = $data["status"];

        $updateSQL="UPDATE sh_hotel_media_map_$sp_id SET status=$status WHERE media_id=$media_id;";
        M('')->execute($updateSQL);

        $sql ="SELECT h.id,hm.media_id FROM sh_hotel h"
            ." LEFT JOIN (SELECT media_id,hotel_id FROM sh_hotel_media_map_$sp_id WHERE media_id=$media_id) hm ON h.id=hm.hotel_id"
            ." WHERE h.sp_id=$sp_id AND media_id IS NULL;";
        $arr = M("")->query($sql);

//        var_dump($arr);

        foreach ($arr as $item){
            $dataList[]=array("media_id"=>$media_id,"hotel_id"=>$item["id"],"status"=>$status,"status_inject"=>0);
        }

        if (!empty($dataList)){
            M("$sp_id","sh_hotel_media_map_")->addAll($dataList);
        }
    }
    public function test_auto_push(){
        $data["sp_id"]=1;
        $data["id"]=300;
        $data["status"]=2;
        $this->media_auto_push($data);
    }

    /**
     * 增量媒资变更列表
     * /Api/Front/incrementList?hid=1&spid=1&start=xxx&end=xxx&page=1
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     *      page    :   请求页
     */
    public function incrementList(){
        $page_size = 10;

        $spid = $_GET["spid"];
        $start = date('Y-m-d H:i:s',strtotime($_GET["start"]));//date('Y-m-d H:i:s', strtotime($date))
        $end = date('Y-m-d H:i:s',strtotime($_GET["end"]));
        $page=$_GET["page"];

        $sqlTotal = "SELECT count(1) total FROM sh_hotel_media_map_$spid WHERE updatetime BETWEEN '$start' AND '$end';";
        $totalArr = M("")->query($sqlTotal);
        $total = 0;
        if (count($totalArr)>0){
            $total = $totalArr[0]["total"];
        }
        $page_num = ceil($total/$page_size);
        $limit_from = ($page-1)*$page_size;
        $sql="SELECT mw.code id,mw.title,mw.description,mw.url_play playUrl,mw.url_pic picUrl"
            .",mw.year,mw.type,mw.score,mw.region,mw.actor,mw.director"
            .",h.code hotelId,hm.status,hm.status_inject statusInject"
            ." FROM (SELECT media_id,hotel_id,status,status_inject FROM sh_hotel_media_map_$spid"
            ." WHERE updatetime BETWEEN'$start' AND '$end' ORDER BY updatetime,media_id ASC LIMIT $limit_from,$page_size) hm"
            ." JOIN sh_media_wasu mw ON mw.id=hm.media_id"
            ." JOIN sh_hotel h ON h.id=hm.hotel_id";

//        echo $sql;exit;
        $list = M("")->query($sql);

        $result["total"]=(int)$total;
        $result["page_cur"]=(int)$page;
        $result["page_num"]=(int)$page_num;
        $result["list"] = $list;

        echo json_encode($result);
        exit;
    }
    /**
     * 增量媒资变更检测接口
     * /Api/Center/incrementCheck?spid=1&start=20190701120000&end=20190702120000&page=1
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     * 输出:
     *  {"total":100,"page_cur":1,"page_num":10}
     */
    public function incrementCheck(){
        $page_size = 10;

        $rawData = @file_get_contents("php://input");
        $json = json_decode($rawData, true);

        if (isset($json["spid"])) {
            $spid = $json["spid"];
            $start = date('Y-m-d H:i:s', strtotime($json["start"]));//date('Y-m-d H:i:s', strtotime($date))
            $end = date('Y-m-d H:i:s', strtotime($json["end"]));
        }else{
            $spid = $_GET["spid"];
            $start = date('Y-m-d H:i:s', strtotime($_GET["start"]));//date('Y-m-d H:i:s', strtotime($date))
            $end = date('Y-m-d H:i:s', strtotime($_GET["end"]));
        }

        $sqlTotal = "SELECT count(1) total FROM sh_hotel_media_map_$spid WHERE updatetime BETWEEN '$start' AND '$end';";
        $totalArr = M("")->query($sqlTotal);
        $total = 0;
        if (count($totalArr)>0){
            $total = (int)$totalArr[0]["total"];
        }
        $page_num = ceil($total/$page_size);

        $result["total"]=$total;
        $result["page_num"]=$page_num;

        echo json_encode($result);
        exit;
    }

    /**
     * 增量媒资变更推送接口
     * /Api/Center/incrementPush
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     *      page    :   请求页
     *      page_num:   总共多少页
     *      url     :   合作方接收地址
     *      key     :   私钥
     * 输出:
     *  {"code":0,"msg":"err msg"}
     */
    public function incrementPush()
    {
        $page_size = 10;

        $rawData = @file_get_contents("php://input");
//        echo "rawData:".$rawData;
        $json = json_decode($rawData, true);

        $spid = $json["spid"];
        $start = date('Y-m-d H:i:s', strtotime($json["start"]));
        $end = date('Y-m-d H:i:s', strtotime($json["end"]));
        $page = $json["page"];
        $pageNum = $json["page_num"];
        $url = $json["url"];
        $key = $json["key"];

        $result["code"] = 0;

        if($url!=""&&$key!="") {

            $limit_from = ($page - 1) * $page_size;
            $sql = "SELECT mw.code id,mw.title,mw.description,mw.programType,mw.url_pic picUrl"
                . ",mw.year,mw.type,mw.score,mw.region,mw.actor,mw.director"
                . ",h.code hotelId,hm.status,hm.status_inject statusInject"
                . " FROM (SELECT media_id,hotel_id,status,status_inject FROM sh_hotel_media_map_$spid"
                . " WHERE updatetime BETWEEN'$start' AND '$end' ORDER BY updatetime,media_id ASC LIMIT $limit_from,$page_size) hm"
                . " JOIN sh_media_wasu mw ON mw.id=hm.media_id"
                . " JOIN sh_hotel h ON h.id=hm.hotel_id";

//        echo $sql;exit;
            $list = M("")->query($sql);//获取增量媒资列表
//            $json = json_encode($list,JSON_UNESCAPED_UNICODE);// php >= 5.4
            $json=json_encode($list);
            //请求合作方接口将变更列表推送
            $sw_time = time();
            $sw_sign = md5($sw_time . $key);
            $api_push = $url . "?sw_time=$sw_time&sw_sign=$sw_sign";

//            echo $api_push;
//            echo "<br/>";
//            echo $sw_time . $key;
//            echo "<br/>";
//            echo $json;
//            exit;

            $data = $this->HttpPost($api_push, $json);
//            echo "post result: ".$data;
            $jsonR = json_decode($data, true);

            if ($jsonR["code"] == 0) {
                //最后一页推送成功:更新offset
                if ($page == $pageNum) {
                    M()->execute("UPDATE sh_sp SET push_offset='$end' WHERE id=$spid;");
                }
            }
            if (!empty($jsonR) && $jsonR["code"]==0){
                $result["code"]=0;
            }else{
                $result["code"]=2001;
                $result["msg"]="合作方接口调用异常:".$data;
            }
        }else{
            $result["code"]=1001;
            $result["msg"]="合作方配置不完整";
        }

        if ($result["code"]!=0){
            $log["sp_id"]=$spid;
            $log["starttime"]=$start;
            $log["endtime"]=$end;
            $log["page"]=$page;
            $log["req_json"]=$rawData;
            $log["resp_json"]=$data;
            $log["code"]=$result["code"];
            D("LogPush")->add($log);
        }
        echo json_encode($result);
        exit;
    }



    public function tb_playlog_create(){
        //参数
        $curMonth = date("Ym");
        $nextMonth = date("Ym",strtotime("+1 month"));

        //创建表
        $srcTable = "sh_log_play";
        $curMonthTable = $srcTable."_".$curMonth;
        $nextMonthTable = $srcTable."_".$nextMonth;

        $this->createTable($srcTable,$curMonthTable);
        $this->createTable($srcTable,$nextMonthTable);
    }


    //------ 表创建方法  ------
    function createTable($srcTable,$targetTable){
        echo $srcTable."->".$targetTable;
        $qsql="SELECT table_name FROM information_schema.TABLES WHERE table_name = '$targetTable';";
        $arrTables = D("")->query($qsql);
        if (count ($arrTables)<=0){
            $csql = "CREATE TABLE $targetTable LIKE $srcTable;";
            D("")->execute($csql);
        }
    }

    function HttpPost($url,$param){
        $ch = curl_init();
        //如果$param是数组的话直接用
        curl_setopt($ch, CURLOPT_URL, $url);
        //如果$param是json格式的数据，则打开下面这个注释
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($param))
        );
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        //如果用的协议是https则打开鞋面这个注释
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

        $data = curl_exec($ch);

        curl_close($ch);
        return $data;

    }
}