<?php
class HotelAction extends CommonAction{
    
    //管理
	public function index(){
		$op = I('op');
        $userInfo = $_SESSION["_USER_INFO"];
		if($op=="getjson"){
			$model = D("Hotel");
			$inputs = I();
			$list = $model->getList("list",$userInfo,$inputs);
			$count = $model->getList("count",$userInfo,$inputs);
			$total = $count[0]["count"];
			echo "{\"total\":\"".$total."\",\"rows\":".json_encode($list)."}";
		}else{
            $spModel = D("Sp");
            $regionModel = D("Region");
            if($userInfo['sp_ids']&&$userInfo['grade']>=3){
                $sp_lists = $spModel->where("`status`=0 and id in(".$userInfo['sp_ids'].")")->select();
            }else{
                $sp_lists = $spModel->where("`status`=0")->select();
            }
            
            $region_lists = $regionModel->where("`level` < 4 and pid < 999999")->select();
            $this->region_lists = $region_lists;
            $this->sp_lists = $sp_lists;
			$this->display();
		}
	}
    
    //添加
	public function add(){

		$userInfo = $_SESSION["_USER_INFO"];
		$id = I('id','',int)?I('id','',int):0;
        
        $model = D("Hotel");
        $spModel = D("Sp");
        $regionModel = D("Region");
        
		if($id){
			$info =$model->where("id = $id")->find();
            $this->info = $info;
		}
        if($userInfo['sp_ids']&&$userInfo['grade']>=3){
            $sp_lists = $spModel->where("`status`=0 and id in(".$userInfo['sp_ids'].")")->select();
        }else{
            $sp_lists = $spModel->where("`status`=0")->select();
        }
        $region_lists = $regionModel->where("pid = 1 and level = 2 and `status`=0")->select();
        $region_city_lists = $regionModel->where("pid > 1 and level = 3 and `status`=0")->select();
        $this->sp_lists = $sp_lists;
        $this->region_lists = $region_lists;
        $this->region_city_lists = $region_city_lists;
		$this->display();
	}
    //添加处理
	public function addHandle(){
		$model = D("Hotel");
		$id = I('id','',int);
        
        $data['sp_id'] = I("sp_id");
        $data['region_id'] = I("region_id");
        $data['name'] = I("name");
        $data['code'] = I("code");
        $data['remark'] = I("remark");
        $data['status'] = I("status");
        
		if($id){
            $data['id'] = $id;
			$data["updatetime"]=date('Y-m-d H:i:s');
            $r = $model->save($data);
			if($r){
				echo 'true';
			}else{
				echo 'false';
			}
		}else{
			$data["addtime"]=date('Y-m-d H:i:s');
			
			$id = $model->add($data);
			if($id){
			    //判断合作方配置(转推模式,如果为自动转推则将相应云端片库数据写入酒店片库表)
                $spid=$data['sp_id'];
                $where["status"]=0;
                $where["sp_id"]=$spid;
                $where["type_code"]="wasu_incrementList_push_mode";
                $push_mode = D("Conf")->field("v")->where($where)->find();
                if ($push_mode["v"]==1) {
                    $sql = "INSERT INTO sh_hotel_media_map_$spid (media_id,hotel_id,status,status_inject)"
                        . " SELECT id,$id,status,0 FROM sh_media_wasu WHERE sp_id=$spid;";
                    $model->execute($sql);
                }

                echo 'true';
			}else{
				echo 'false';
			}
		}
	}
    
    //删除处理
	public function deleteHandle(){
		if(D("Hotel")->where("id=".I("id","",int))->delete()){
			echo 'true';
		}else{
			echo 'false';
		}
	}
    
    //ajax修改状态
	public function updateStatusAjaxHandle(){
        $model = D("Hotel");
        $data = $_POST;
        $data['updatetime'] = date('Y-m-d H:i:s');
        if($model->save($data)){
            echo 'true';
        }else{
            echo 'false';
        }
	}
}
