<?php

require_once './App/PHPGangsta/GoogleAuthenticator.php';

class UserAction extends CommonAction{
//用户管理
	public function addUser(){
		$userInfo = $_SESSION["_USER_INFO"];
		if($userInfo['grade']>1){//服务商或SP
			$role=D("Role")->where("(type=0 and grade>".$userInfo["grade"].") or (grade>=".$userInfo['grade']." and vdgo_id=".$userInfo["my_vdgo_id"].")")->select();//type=0 and grade>自身等级的预置角色+该网络服务商所定义的角色
			$myDeviceGroupOwnerList=D("DeviceGroupOwner")->where("VDGO_DELETETYPE=0 AND VDGO_ID=".$userInfo['my_vdgo_id'])->select();
			$otherDeviceGroupOwnerList=D("DeviceGroupOwner")->where("VDGO_DELETETYPE=0 AND VDGO_ID IN (".$userInfo['other_vdgo_ids'].")")->select();
			$bizUserList=D("BizUser")->where("VBU_VDGOID=".$userInfo['my_vdgo_id'])->select();
		}else{//SOOONER/sysadmin
			$role=D("Role")->where("grade>0")->select();//grade!=0的所有角色
			$myDeviceGroupOwnerList=D("DeviceGroupOwner")->where("VDGO_DELETETYPE=0")->select();
			$otherDeviceGroupOwnerList=$myDeviceGroupOwnerList;
			$bizUserList=D("BizUser")->select();
		}
        
        $spModel = D("Sp");
        $sp_lists = $spModel->field("id,`name`")->where("`status`=0")->select();
        
		$id = I('id','',int);
		if($id){
			$userModel = D("User");
			$user=$userModel->getUserInfo($id);
			$user=$user[0];
            
            $sp_lists = $spModel->field("A.id,A.`name`,if(B.`status`=0,'true',null) as selected")->join("A left join sh_sp_user_map B on A.id = B.sp_id and B.user_id = $id")->where("A.`status`=0")->select();
			foreach ($role as $key=>$value){
				if($role[$key]['id']==$user['role_id'])
					$role[$key]['selected']='selected';
			}
			foreach ($myDeviceGroupOwnerList as $key=>$value){
				if($myDeviceGroupOwnerList[$key]['VDGO_ID']==$user['my_vdgo_id'])
					$myDeviceGroupOwnerList[$key]['selected']='selected';
			}
			foreach($otherDeviceGroupOwnerList as $key=>$value){
				$arr=explode(",",$user['other_vdgo_ids']);
				if(in_array($otherDeviceGroupOwnerList[$key]['VDGO_ID'], $arr))
					$otherDeviceGroupOwnerList[$key]['selected']='selected';
			}
			foreach($bizUserList as $key=>$value){
				$arr=explode(",",$user['biz_list']);
				if(in_array($bizUserList[$key]['VBU_ACCOUNTS'], $arr))
					$bizUserList[$key]['selected']='selected';
			}
		}
        $this->sp_lists = $sp_lists;
		$this->assign('user',$user);
		$this->assign('role',$role);
		$this->assign('myDeviceGroupOwnerList',$myDeviceGroupOwnerList);
		$this->assign('otherDeviceGroupOwnerList',$otherDeviceGroupOwnerList);
		$this->assign('bizUserList',$bizUserList);
		$this->display();
	}
	public function addUserHandle(){
        $ga = new PHPGangsta_GoogleAuthenticator();
		$UserModel = D("User");
		$RoleUserModel = D("RoleUser");
        $SpUserMapModel = D("SpUserMap");
		$user["account"]=$_POST["account"];
		$user["password"]=I("password","","md5");//
		$user["nickname"]=$_POST["nickname"];
		$user["email"]=$_POST["email"];
		$user["tel"]=$_POST["tel"];
		$user["status"]=$_POST["status"];
//		$user["my_vdgo_id"]=$_POST["my_vdgo_id"];
//		$user["other_vdgo_ids"]=implode(",",$_POST['other_vdgo_ids'])?implode(",",$_POST['other_vdgo_ids']):"";
//		$user["biz_list"]=implode(",",$_POST['biz_list'])?implode(",",$_POST['biz_list']):"";
		$roleInfo=D("Role")->where("id=".$_POST["role_id"])->find();
		$user["grade"]=$roleInfo["grade"];//用户等级与所选角色等级一致
		//dump($user);exit;
		$uid = $_POST['id'];
        $sp_ids = $_POST['sp_id']; //表sh_sp_user_map绑定
		if($uid){
			$user["id"]=$uid;
			$user["update_time"]=time();
            $SpUserMapModel->where("user_id = $uid")->delete();
            if($sp_ids){
                $mapData = array();
                foreach($sp_ids as $key=>$value){
                    $mapData[] = array("user_id"=>$uid,"sp_id"=>$value,"status"=>0,"addtime"=>date("Y-m-d H:i:s"));
                }
                $SpUserMapModel->addAll($mapData);
            }
			unset($user['account']);
			unset($user['password']);

            $user["secret"]=$_POST["secret"];
            if ($user["secret"]==""){
                $secret = $ga->createSecret();
                $user["secret"]=$secret;
            }

			if($UserModel->save($user)){
				if($RoleUserModel->where("user_id=".$uid)->delete()){
					$role["role_id"]=I("role_id","",int);
					$role["user_id"]=$uid;
					if($RoleUserModel->add($role)){
						echo 'true';
					}else{
						echo 'false';
					}
				}
			}else{
				echo 'true';
			}
		}else{
			$user["create_time"]=time();	
			$user["create_by"]=$_SESSION['_USER_INFO']['account'];
			$user["last_login_time"]=time();
			$user["last_login_ip"]="127.0.0.1";
            $user["update_time"]=time();
            $user["remark"]='';


            $secret = $ga->createSecret();
            $user["secret"]=$secret;
			
			$uid = $UserModel->add($user);

            
            $SpUserMapModel->where("user_id = $uid")->delete();
            if($sp_ids){
                $mapData = array();
                foreach($sp_ids as $key=>$value){
                    $mapData[] = array("user_id"=>$uid,"sp_id"=>$value,"status"=>0,"addtime"=>date("Y-m-d H:i:s"));
                }
                $SpUserMapModel->addAll($mapData);
            }
            
			if($uid){
				$role["role_id"]=I("role_id","",int);
				$role["user_id"]=$uid;
				if($RoleUserModel->add($role)){
					echo 'true';
				}else{
					echo 'false';
				}
			}
			else{
				echo 'false';
			}
		}
	}
	public function userList(){
		$op = I('op');
		if($op=="getjson"){
			$userModel = D("User");
			$userInfo = $_SESSION["_USER_INFO"];
			$inputs = I();
			$list = $userModel->getUserList("list",$userInfo,$inputs);
			$count = $userModel->getUserList("count",$userInfo,$inputs);
			$total = $count[0]["count"];
			echo "{\"total\":\"".$total."\",\"rows\":".json_encode($list)."}";
		}else{
			$this->display();
		}
	}
	public function deleteUserHandle(){
		if(D("User")->where("id=".I("id","",int))->delete()){
			D("RoleUser")->where("user_id=".I("id","",int))->delete();
			echo 'true';
		}else{
			echo 'false';
		}
	}
	//ajax修改
	public function updateUserAjaxHandle(){
		$userModel = D("User");
		$op = $_POST["op"];
		if($op=="modifypass"){
			$data['id'] = $_POST['id'];
			$data['password']= I("password","","md5");
			if($userModel->save($data)){
				echo 'true';
			}else{
				echo 'false';
			}
		}else{
			$data = $_POST;
			if($userModel->save($data)){
				echo 'true';
			}else{
				echo 'false';
			}
		}
	}
	public function checkloginname(){
		$account=I('account');
		$userModel = D("User");
		$userInfo = $userModel->where("account='".$account."'")->find();
		if($userInfo)
			echo "false";
		else
			echo "true";
	}
}
