<?php
class PlayLogModel extends RelationModel{
	protected $tableName = 'sh_log_play'; //重新定义表名

    public function getList($queryType,$userInfo,$inputs){
		$p=$inputs["page"]?$inputs["page"]:1;
		$n=$inputs["rows"]?$inputs["rows"]:10;
		$limit = "limit ".($p-1)*$n.",".$n;
		$sort="";
		if($inputs["sort"])
			$sort = "order by ".$inputs["sort"]." ".$inputs["order"];
		//=============
		$searchField = $inputs["searchField"]?$inputs["searchField"]:'name';
		$searchValue = $inputs["searchValue"]?$inputs["searchValue"]:'';
        $searchSp = $inputs["searchSp"]?$inputs["searchSp"]:0;
        $searchHotel = $inputs["searchHotel"]?$inputs["searchHotel"]:0;
        $searchMonth = $inputs["searchMonth"]?$inputs["searchMonth"]:date("Ym");
        
        if($searchValue){
            $where = " and (A.`stb_id` like '%".$searchValue."%' or A.`order_id` like '%".$searchValue."%') ";
        }
        if($searchSp){
            $where .= " and A.sp_id = $searchSp ";
        }
        if($searchHotel){
            $where .= " and A.hotel_id = $searchHotel ";
        }
        if($userInfo['sp_ids']&&$userInfo['grade']>=3){
            $where .= " and A.sp_id in(".$userInfo['sp_ids'].") ";
        }
        $model = new Model();

		//======================
		$fields = "count(A.id) count";
		//返回列表（limit分页）
		if($queryType=="list"){
			$where .= $sort." ".$limit;
			$fields = " A.*,B.`name` sp_name,C.`name` hotel_name,D.`title` media_name ";
		}
		$sql = "select ".$fields." from sh_log_play_$searchMonth A"
		    ." join sh_sp B on A.sp_id=B.id"
            ." join sh_hotel C on A.hotel_id=C.id"
            ." join sh_media_wasu D on A.media_id=D.`code` and A.sp_id = D.sp_id"
            ." where 1=1 ".$where.";";
//        echo $sql;
		return $model->query($sql);
	}
}