<?php
class RegionModel extends RelationModel{
	protected $tableName = 'sh_region'; //重新定义表名

    public function getList($queryType,$userInfo,$inputs){
		$p=$inputs["page"]?$inputs["page"]:1;
		$n=$inputs["rows"]?$inputs["rows"]:4000;
		$limit = "limit ".($p-1)*$n.",".$n;
		$sort="";
		if($inputs["sort"])
			$sort = "order by ".$inputs["sort"]." ".$inputs["order"];
		//=============
		$searchField = $inputs["searchField"]?$inputs["searchField"]:'name';
		$searchValue = $inputs["searchValue"]?$inputs["searchValue"]:'';
        $searchPid = $inputs["searchPid"]?$inputs["searchPid"]:1;
        
        if($searchValue){
            $where = " and (`name` like '%".$searchValue."%' or `mac` like '%".$searchValue."%') ";
        }

        $model = new Model();

		//======================
		$fields = "count(id) count";
		//返回列表（limit分页）
		if($queryType=="list"){
			$where .= $sort." ".$limit;
			$fields = " id,`name` title,`code`,`level`,`status`,postcode,updatetime,if(`level`>1 and `level`<4,'closed','open') as `state`,case pid when 1 then 0 else pid end as `pid` ";
		}
		$sql = "select ".$fields." from sh_region where 1=1 and pid < 999999 and pid = $searchPid ".$where.";";
//        echo $sql;die;
		return $model->query($sql);
	}
}