package Unit

import (
	"strconv"
)

//将 1m/1h/1d 转换成秒
func Time2Seconds(str string) int {
	seconds, err := strconv.Atoi(str)
	if err != nil { //转换失败

		rs := []rune(str)
		lth := len(rs)
		sNum := string(rs[0 : lth-1])    //数值
		sUnit := string(rs[lth-1 : lth]) //单位：s-秒，m-分钟，h-小时,d-天

		n, err1 := strconv.Atoi(sNum)
		if err1 == nil {
			switch sUnit {
			case "s":
				seconds = n
				break
			case "m":
				seconds = n * 60
				break
			case "h":
				seconds = n * 3600
				break
			case "d":
				seconds = n * 3600 * 24
				break
			default:
				seconds = 3600 * 24
				break
			}
		} else {
			seconds = 60 //
		}
	}

	//ret := strconv.Itoa(seconds)
	// fmt.Println("Time2Seconds : ", str, "  --> ", ret)

	return seconds
}
