<?php
class PlayCtrlLogModel extends RelationModel{
	protected $tableName = 'sh_task_ctrl_log'; //重新定义表名

    public function getList($queryType,$userInfo,$inputs){
		$p=$inputs["page"]?$inputs["page"]:1;
		$n=$inputs["rows"]?$inputs["rows"]:10;
		$limit = "limit ".($p-1)*$n.",".$n;
		$sort="";
		if($inputs["sort"])
			$sort = "order by ".$inputs["sort"]." ".$inputs["order"];
		//=============
		$searchField = $inputs["searchField"]?$inputs["searchField"]:'name';
		$searchValue = $inputs["searchValue"]?$inputs["searchValue"]:'';
        $searchSp = $inputs["searchSp"]?$inputs["searchSp"]:0;
        $searchHotel = $inputs["searchHotel"]?$inputs["searchHotel"]:0;
        $searchTaskID = $inputs["searchTaskID"]?$inputs["searchTaskID"]:0;
        
        if($searchValue){
            $where = " and (A.`name` like '%".$searchValue."%') ";
        }
        
        if($searchSp){
            $where .= " and A.sp_id = $searchSp ";
        }
        
        if($searchHotel){
            $where .= " and A.hotel_id = $searchHotel ";
        }
        
        if($searchTaskID){
            $where .= " and A.task_id = $searchTaskID ";
        }
        
        if($userInfo['sp_ids']&&$userInfo['grade']>=3){
            $where .= " and A.sp_id in(".$userInfo['sp_ids'].") ";
        }

        $model = new Model();

		//======================
		$fields = "count(A.id) count";
		//返回列表（limit分页）
		if($queryType=="list"){
			$where .= $sort." ".$limit;
			$fields = " A.id,A.addtime,A.updatetime,E.`name` task_name,B.`title` media_name,C.`name` hotel_name,D.`name` sp_name,case A.`status` when 0 then '<font color=red>删除</font>' when 1 then '<font color=green>上线</font>' when 2 then '<font color=red>下线</font>' end as `status` ";
		}
		$sql = "select ".$fields." from sh_task_ctrl_log A join sh_task_ctrl E on A.task_id = E.id join sh_media_wasu B on A.media_id = B.id join sh_hotel C on A.hotel_id = C.id join sh_sp D on A.sp_id = D.id where 1=1 ".$where.";";
//        echo $sql;
		return $model->query($sql);
	}
}